#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <arpa/inet.h>

#include "rdesktop.h"

const int tcp_port_rdp = 3389;
int create_server_socket();
int serve_client();

int main()
{
	int server_sock = create_server_socket();
	for ( ;; ) {
		iso_recv_connect(server_sock);
		printf("Got connection.\n");
		serve_client();
		printf("Client closed.\n");
	}
}

int create_server_socket()
{
	int server_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	const unsigned int one = 1, zero = 0;
	struct sockaddr_in addr;
	int err;

	setsockopt(server_sock, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(one));
	ioctl(server_sock, FIONBIO, &zero);

	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY;
	addr.sin_port = htons(tcp_port_rdp);

	do {
		err = bind(server_sock, (struct sockaddr *)&addr, sizeof(struct sockaddr));

		if (err == -1) {
			perror("bind()");

			/* try to recover from recoverable errors... */
			if (errno == ENOMEM || errno == EADDRINUSE) {
				puts("Waiting 1 sec before trying again...");
				sleep(1);
			} else {
				puts("Giving up.");
				exit(1);
			}
		}
	} while (err == -1);

	listen(server_sock, 20);
	return server_sock;
}


int serve_client()
{
	mcs_recv_connect_initial();
	mcs_send_connect_response();
	
	for ( ;; ) {
		short channel;
		
		/* receive ISO packets */
		mcs_recv(&channel);

		printf("Packet on ch %u\n", channel);
	}
}
